/*
 * generated by Xtext
 */
package de.ugoe.cs.swe.ui;

import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.eclipse.xtext.builder.IXtextBuilderParticipant;
import org.eclipse.xtext.builder.nature.NatureAddingEditorCallback;
import org.eclipse.xtext.ide.editor.model.TokenTypeToStringMapper;
import org.eclipse.xtext.ide.editor.syntaxcoloring.AbstractAntlrTokenToAttributeIdMapper;
import org.eclipse.xtext.ide.editor.syntaxcoloring.ISemanticHighlightingCalculator;
import org.eclipse.xtext.ui.editor.IXtextEditorCallback;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfiguration;

import com.google.common.base.Predicate;
import com.google.inject.Binder;
import com.google.inject.name.Names;

import de.ugoe.cs.swe.ui.preferences.TTCN3RootPreferencePage;
import de.ugoe.cs.swe.ui.syntaxcoloring.TTCN3HighlightingCalculator;
import de.ugoe.cs.swe.ui.syntaxcoloring.TTCN3HighlightingConfiguration;
import de.ugoe.cs.swe.ui.syntaxcoloring.TTCN3TokenToAttributeIdMapper;

/**
 * Use this class to register components to be used within the IDE.
 */
public class TTCN3UiModule extends de.ugoe.cs.swe.ui.AbstractTTCN3UiModule {
	public TTCN3UiModule(AbstractUIPlugin plugin) {
		super(plugin);
	}
	public Class<? extends IXtextBuilderParticipant> bindIXtextBuilderParticipant() {
        return ScopeRebuild.class;
    }
	//@Override
    public Class<? extends IHighlightingConfiguration> bindIHighlightingConfiguration() {
        return TTCN3HighlightingConfiguration.class;
    }
    public Class<? extends AbstractAntlrTokenToAttributeIdMapper> bindAbstractAntlrTokenToAttributeIdMapper() {
        return TTCN3TokenToAttributeIdMapper.class;
    }
	public Class<? extends ISemanticHighlightingCalculator> bindISemanticHighlightingCalculator() {
		return TTCN3HighlightingCalculator.class;
	}
	
	public Class<? extends org.eclipse.xtext.ui.editor.preferences.LanguageRootPreferencePage> bindLanguageRootPreferencePage() {
		return TTCN3RootPreferencePage.class;
	}

	@Override
    public void configure(Binder binder) {
        super.configure(binder);
        binder.bind(TokenTypeToStringMapper.class).to(TTCN3TokenToAttributeIdMapper.class);
        binder.bind(Predicate.class).annotatedWith(Names.named("ePackageUriFilter")).toInstance(new Predicate<String>() {
//            @Override
            public boolean apply(String input) {
                if (input.startsWith("http://www.eclipse.org/emf") && !input.equals(EcorePackage.eNS_URI))
                    return true;
                return false;
            }
        });
    }
    
	public Class<? extends IXtextEditorCallback> bindIXtextEditorCallback() {
	    return NatureAddingEditorCallback.class;
	}

}
